
package de.ivu.elect.business.person.boundary;

import javax.inject.Inject;

import de.ivu.elect.business.person.entity.Kreditinstitut;

// abgeleitete Klasse mit "@javax.ejb.Stateless" annotieren!
public abstract class AbstractKreditinstitutEdit {

  @Inject
  protected KreditinstitutDAO dao;

  @Inject
  protected KreditinstitutExtendedDAO extendedDao;

  public void delete(Kreditinstitut entity) {
    dao.remove(getAttachedEntity(entity));
  }

  public void save(Kreditinstitut entity) {
    validate(entity);

    flushToSave();
  }

  protected void validate(Kreditinstitut entity) {
    // Do nothing by default.
  }

  protected void flushToSave() {
    if(usesMixedTransactionalContexts()) {
        extendedDao.flushNewTransaction();
    } else {
        extendedDao.flush();
    }
  }

  // ELECT-945
  protected boolean usesMixedTransactionalContexts() {
    return false;
  }

  protected Kreditinstitut getAttachedEntity(Kreditinstitut entity) {
    return dao.findByPrimaryKey(entity.getPk());
  }

  // Cf. ELECT-3187 (Änderungen an Entität werden nicht gespeichert)
  protected Kreditinstitut getAttachedAndRefreshedEntity(Kreditinstitut entity) {
    return dao.refresh(entity);
  }
}
